<?php

namespace Drupal\twitter_sync\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

class TwitterSyncSettupForm extends ConfigFormBase {

  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames (){
    return ['twitter_sync_settup_form.settings'];
  }

  /**
   * {@inheritdoc}
   */
  public function getFormId (){
    return 'twitter-sync-settup-form';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $config = $this->config('twitter_sync_settup_form.settings');

    $form['field_twitter_sync_consumer_key'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Consumer Key'),
      '#required' => TRUE,
      '#default_value' => $config->get('field_twitter_sync_consumer_key'),
    ];
    $form['field_twitter_sync_consumer_secret'] = [
      '#type' => 'textfield',
      '#required' => TRUE,
      '#title' => $this->t('Consumer secret'),
      '#default_value' => $config->get('field_twitter_sync_consumer_secret'),
    ];
    $form['field_twitter_sync_access_token'] = [
      '#type' => 'textfield',
      '#required' => TRUE,
      '#title' => $this->t('Access token'),
      '#default_value' => $config->get('field_twitter_sync_access_token'),
    ];
    $form['field_twitter_sync_access_token_secret'] = [
      '#type' => 'textfield',
      '#required' => TRUE,
      '#title' => $this->t('Access token secret'),
      '#default_value' => $config->get('field_twitter_sync_access_token_secret'),
    ];

    // Screen name
    $form['field_twitter_screen_name'] = [
      '#type' => 'textfield',
      '#required' => TRUE,
      '#title' => $this->t('Screen Name'),
      '#default_value' => $config->get('field_twitter_screen_name'),
    ];

    return parent::buildForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    // Retrieve the configuration.
    $this->configFactory->getEditable('twitter_sync_settup_form.settings')
      // Set the submitted configuration setting.
      ->set('field_twitter_sync_consumer_key', $form_state->getValue('field_twitter_sync_consumer_key'))
      ->set('field_twitter_sync_consumer_secret', $form_state->getValue('field_twitter_sync_consumer_secret'))
      ->set('field_twitter_sync_access_token', $form_state->getValue('field_twitter_sync_access_token'))
      ->set('field_twitter_sync_access_token_secret', $form_state->getValue('field_twitter_sync_access_token_secret'))
      ->set('field_twitter_screen_name', $form_state->getValue('field_twitter_screen_name'))
      ->save();

    parent::submitForm($form, $form_state);
  }
}
